/* copy.h
 *
 * Copyright 2001-2002 Vesa Halttunen (Vesuri/dA JoRMaS)
 *
 * This file is part of JRm-core.
 *
 * JRm-core is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * JRm-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JRm-core; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _COPY_H
#define _COPY_H

#include "buffer.h"
#include "effect.h"

/* Copy effect data structure */
struct copy_data
{
  buffer *source;
  buffer *dest;
  int sourcex;
  int sourcey;
  int destx;
  int desty;
  int sourcewidth;
  int sourceheight;
  int destwidth;
  int destheight;
  unsigned char alpha;
  unsigned char mode;
  unsigned char interpolate;
};
typedef struct copy_data copy_data;

/* Copying modes */
#define COPY_MODE_NORMAL      0
#define COPY_MODE_ADD         1
#define COPY_MODE_OVERWRITE   2

/* copy.c functions */
/*****************************************************************************/
/**                           PROTOTYPES                                    **/
/*****************************************************************************/
extern void copy_new(effect *);

#endif
